<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suifmath.texi on 28 April 1999 -->

<TITLE>The SUIFMATH Library - Constraint Math</TITLE>
<link href="suifmath_15.html" rel=Next>
<link href="suifmath_13.html" rel=Previous>
<link href="suifmath_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_13.html">previous</A>, <A HREF="suifmath_15.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC14" HREF="suifmath_toc.html#TOC14">Constraint Math</A></H3>
<P>
<A NAME="IDX282"></A>
<A NAME="IDX283"></A>

</P>
<P>
Assume <VAR>a</VAR>, <VAR>b</VAR> and  <VAR>c</VAR> are of the class
<CODE>constraint</CODE>; <VAR>x</VAR>, <VAR>i</VAR> and <VAR>j</VAR> are
integers and <CODE>o</CODE> is a boolean.

</P>
<DL COMPACT>

<DT><CODE>x = a[i];</CODE>
<DD>
<DT><CODE>a[i] = y;</CODE>
<DD>
Read and modify the <VAR>i</VAR>-th element  of the constraint <VAR>a</VAR>.
The first element is the constant. The subsequent elements are
coefficients. 
<A NAME="IDX284"></A>
<A NAME="IDX285"></A>

<DT><CODE>o = (a == b);</CODE>
<DD>
Are rows <VAR>a</VAR> and <VAR>b</VAR> are identical?  (<CODE>!=</CODE> is also available)
<A NAME="IDX286"></A>
<A NAME="IDX287"></A>
<A NAME="IDX288"></A>

<DT><CODE>c = a + b;</CODE>
<DD>
Add the corresponding elements of the two constraints <VAR>a</VAR> and
<VAR>b</VAR>, and put the results in <VAR>c</VAR>.  
<A NAME="IDX289"></A>
<A NAME="IDX290"></A>

<DT><CODE>c = a - b;</CODE>
<DD>
Subtract the corresponding elements of the two constraints <VAR>a</VAR> and
<VAR>b</VAR>, and put the results in <VAR>c</VAR>. 
<A NAME="IDX291"></A>
<A NAME="IDX292"></A>

<DT><CODE>c = a * b;</CODE>
<DD>
Multiply the corresponding elements of <VAR>a</VAR> and <VAR>b</VAR>, and put
the results in <VAR>c</VAR>.  
<A NAME="IDX293"></A>
<A NAME="IDX294"></A>

<DT><CODE>c += a;</CODE>
<DD>
Add the corresponding elements of <VAR>a</VAR> to the row <VAR>c</VAR>.
<A NAME="IDX295"></A>
<A NAME="IDX296"></A>

<DT><CODE>c -= a;</CODE>
<DD>
Subtract the corresponding elements of <VAR>a</VAR> from the row <VAR>c</VAR>.
<A NAME="IDX297"></A>
<A NAME="IDX298"></A>

<DT><CODE>c *= a;</CODE>
<DD>
Multiply the elements of <VAR>c</VAR> by the corresponding elements of <VAR>a</VAR>.
<A NAME="IDX299"></A>
<A NAME="IDX300"></A>

<DT><CODE>c = a + x;</CODE>
<DD>
Add the integer <VAR>x</VAR> to each element of <VAR>a</VAR>, and put the results in
<VAR>c</VAR>. 
<A NAME="IDX301"></A>
<A NAME="IDX302"></A>

<DT><CODE>c = a - x;</CODE>
<DD>
Subtract the integer <VAR>x</VAR> form each element of <VAR>a</VAR>, and put
the results in the row <VAR>c</VAR>. 
<A NAME="IDX303"></A>
<A NAME="IDX304"></A>

<DT><CODE>c = a * x;</CODE>
<DD>
Multiply each element of <VAR>a</VAR> by the integer <VAR>x</VAR>, and put
the results in the row <VAR>c</VAR>. 
<A NAME="IDX305"></A>
<A NAME="IDX306"></A>

<DT><CODE>c = a / x;</CODE>
<DD>
Divide each element of <VAR>a</VAR> by the integer <VAR>x</VAR>, and put the results
in the row <VAR>c</VAR>. 
<A NAME="IDX307"></A>
<A NAME="IDX308"></A>

<DT><CODE>c += x;</CODE>
<DD>
Add the integer <VAR>x</VAR> to each element of <VAR>c</VAR>.
<A NAME="IDX309"></A>
<A NAME="IDX310"></A>

<DT><CODE>c -= x;</CODE>
<DD>
Subtract the integer <VAR>x</VAR> from each element of <VAR>c</VAR>.
<A NAME="IDX311"></A>
<A NAME="IDX312"></A>

<DT><CODE>c *= x;</CODE>
<DD>
Multiply each element of <VAR>a</VAR> by the integer <VAR>x</VAR>.
<A NAME="IDX313"></A>
<A NAME="IDX314"></A>

<DT><CODE>c /= x;</CODE>
<DD>
Divide each element of <VAR>a</VAR> by the integer <VAR>x</VAR>.
<A NAME="IDX315"></A>
<A NAME="IDX316"></A>

<DT><CODE>a = b.complement();</CODE>
<DD>
<DT><CODE>a = -b;</CODE>
<DD>
<A NAME="IDX317"></A>
<A NAME="IDX318"></A>
Complement the constraint. The complement of the constraint <VAR>A &#62;= 0</VAR>
is <VAR>A &#60; 0</VAR>.

<DT><CODE>i = a.row_lcm();</CODE>
<DD>
<A NAME="IDX319"></A>
<A NAME="IDX320"></A>
Find the largest common multiplier of all the elements of the constraint.

<DT><CODE>i = a.row_gcd();</CODE>
<DD>
<A NAME="IDX321"></A>
<A NAME="IDX322"></A>
Find the greatest common divisor of all the elements of the constraint.

<DT><CODE>i = a.rank()</CODE>
<DD>
<A NAME="IDX323"></A>
Return the position of the highest column with a non-zero value.

<DT><CODE>i = a.unique()</CODE>
<DD>
<A NAME="IDX324"></A>
Only one non-zero variable (<VAR>a[0]</VAR> is the constant). 

<DT><CODE>i = a.highest_order(b);</CODE>
<DD>
<A NAME="IDX325"></A>
<A NAME="IDX326"></A>
Return an integer val s.t. for all locations <CODE>x</CODE> of <VAR>a</VAR>,
if <VAR>a[x]!=0</VAR> then <VAR>val += b[c]</VAR>.     

</DL>


<PRE>

</PRE>

<P><HR><P>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_13.html">previous</A>, <A HREF="suifmath_15.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
</BODY>
</HTML>
